/**
 ** Copyright (c) 1999-2003 LAAS/CNRS 
 **
 ** Matthieu Herrb - Mon Mar  8 1999
 **
 ** $Source: /cvs/openrobots/modules/segloc/codels/seglocReadLaserData.c,v $
 ** $Revision: 1.2 $
 ** $Date: 2006/12/01 13:43:37 $
 ** 
 **/

#ident "$Id: seglocReadLaserData.c,v 1.2 2006/12/01 13:43:37 mransan Exp $"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "lasdef.h"
#include "las_struct_p.h"
#include "mat.h"
#include "image_mgr_p.h"

#include "lasers_robots.h"
#include "las_unc_p.h"

#ifndef VXWORKS
# include "portLib.h"
#else
#include <vxWorks.h>
#endif
 
#include "posterLib.h"
#include "pomStruct.h"
#include "sickStruct.h"

#include "server/seglocPosterReadLibProto.h"

#include "seglocReadLaserData.h"
#include "sick_save.h"

/* ------------------------------------------------------------
 *
 *  seglocReadLaserData  -  
 *
 *
 */
BOOL seglocReadLaserData(int fromFile, char *name,
			 SICK_MEASURES_STR *measures)
{
  static POSTER_ID posterId=NULL;
  static unsigned int prevDate=-1;
  static int count=0;

   /**
    ** DATA FROM POSTER
    **/
    if (!fromFile) {

      /* Get poster id */
      if (!posterId) {
	if (posterFind(name, &posterId) == ERROR) {
	  printf ("seglocLaserImageRead: cannot find poster %s\n", name);
	  return FALSE;
	}
      }

      /* Lecture du poster */
      if(seglocSICK_MEASURES_STRPosterRead(posterId, measures) != OK) {
	printf ("SickGet_image: sickScanHeaderPosterRead failed\n");
	posterId=NULL;
	return FALSE;
      }

      
      /* test fresh data */
      if (measures->header.rcv_time == prevDate) {
	if (count>0)
	  printf("** segloc: sick not updated %d times (date %d)\n", 
		 count, measures->header.rcv_time);
	count++;
      }
      else
	count = 0;
      if (count > 30) {
	printf("** segloc: sick not updated %d times (date %d)\n", 
	       30, measures->header.rcv_time);
	posterId=NULL;
	return FALSE;
      }
      prevDate = measures->header.rcv_time;
    }

    /**
     ** DATA FROM FILE
     **/
    else {
      if (!sickReadFile(name, NULL, &measures->header, measures->rho)) {
	printf ("InitSick: sickReadFile %s failed\n", name);
	return FALSE;
      }
    }

    /* test data validity */
    if (measures->header.np <= 0) {
      printf ("InitSick: bad data in %s\n", name);
      return FALSE;
    }
    return TRUE;
}
