/**
 **  To clip map 
 **
 **/


#include <stdio.h>
#include <sys/types.h>
#ifndef VXWORKS
#include <time.h>
#include <termios.h>
#endif
#include <unistd.h>
#include <stdlib.h>

#include <dbliste.h>
#include <lasdef.h>    /* igla ... */
#include <las_struct_p.h>  /* proto */
#include <las_io_p.h>  /* rd_file_sg_c .. */
#include "seglocMapUtils.h"


#ifdef VXWORKS
#include <vxWorks.h>
#endif
#include <stdio.h>

#ifdef DEBUG
static long wrt_file_sg_c_stdout(igla *igl);
#endif

#ifdef VXWORKS
void clip_map(char *filein, 
	      double xmin, double xmax, double ymin, double ymax,
	      char *fileout)
#else
void main(int argc, char **argv)
#endif
{
  igla *igin;
  FILE *ptr;

#ifdef UNIX
  char *filein;
  double xmin;
  double xmax;
  double ymin;
  double ymax;
  char *fileout;

  if (argc != 7) {
    printf ("usage: seg_clip_map(char *filein, "
	    "double xmin, double xmax, double ymin, double ymax,"
	    "char *fileout)\n");
    exit(1);
  }
  filein = argv[1];
  xmin = atof(argv[2]);
  xmax = atof(argv[3]);
  ymin = atof(argv[4]);
  ymax = atof(argv[5]);
  fileout  = argv[6];

  printf ("args : filein %s  -> fileout %s\n"
	  "        xmin %g  xmax %g  ymin %g  ymax %g  \n",
	  filein, fileout, xmin, xmax, ymin, ymax);
#endif UNIX

  if((ptr = fopen(fileout,"w+")) == NULL){
    printf("can't open file %s\n",fileout);
    return;
  }
  fclose(ptr);

  igin = Imgl_cree();

  rd_file_sg_c(igin, filein);

  if (!seglocRemoveRectangle(igin, xmin, xmax, ymin, ymax)) {
    printf ("seglocRemoveRectangle ERROR\n");
    return ;
  }

  /* Nouveau fichier */
#ifdef DEBUG
  wrt_file_sg_c_stdout(igin);
#else
  wrt_file_sg_c(igin, fileout);
#endif

  /* On libre tout */
  Imgl_free(igin);

}

 
#ifdef DEBUG
static long wrt_file_sg_c_stdout(igla *igl)
     
{

  
  
  PDBL *l;
  Sgl *s;
  FILE *ptr=stdout;
 

  if(igl->lsgl == NULL) {
    printf ("nothing \n");
    return(-1);
  }

    
  fprintf(ptr,"%ld \n",igl->nsg);
    
  fprintf(ptr,"%.4f %.4f %.5f %.5f %.5f %.5f %c \n",
	  igl->x,igl->y,igl->cs,igl->sn,igl->cst,igl->snt,igl->coosys);
  fprintf(ptr,"%.4f %.4f %.4f %.4f \n",igl->enc[0],igl->enc[1],
	  igl->enc[2],igl->enc[3]);
  for(l = igl->lsgl; l != NULL; l = dls(l)){
    
    s = (Sgl *)dlel(l);
    
    fprintf(ptr, "%.4f ",s->first.x);
    fprintf(ptr, "%.4f \n",s->first.y);
    fprintf(ptr, "%.4f ",s->last.x);
    fprintf(ptr, "%.4f \n",s->last.y);
    fprintf(ptr, "%.7f %.7f %.7f \n",s->vx,s->vy,s->d);
    fprintf(ptr, "%.7f %.7f \n",s->r,s->o);
    fprintf(ptr, "%.7f %.7f %.7f \n",s->vr,s->vro,s->vo);
    fprintf(ptr, "%c %c \n",s->typf,s->typl);
    

  }

  return(1);
}
#endif
