#include <stdio.h>
#include <stdlib.h>
#include <portLib.h>
#include <posterLib.h>

#include "server/pomClient.h"
#include "seglocStruct.h"
#include "seglocMapIO.h"

void main(int argc, char **argv)
{
  char *filein;
  char *fileout;
  SEGKIT_MAP_HEADER header;
  SEGKIT_SEG *segs;

  if (argc != 3) {
    printf ("usage: test_io(char *filein,  char *fileout)\n");
    exit(1);
  }
  filein = argv[1];
  fileout  = argv[2];

  printf ("args : filein %s  -> fileout %s\n",
	  filein, fileout);

  if ((segs = seglocReadSegkitMap(filein, &header)) == NULL) {
    printf ("seglocReadSegkitMap failed\n");
    return ;
  }

  if (!seglocWriteSegkitMap(fileout, &header, segs))
    printf ("seglocWriteSegkitMap failed\n");

  free(segs);
  return ;
}
  
