#ifndef SEGLOC_STATS_IO_H
#define SEGLOC_STATS_IO_H


typedef enum SEGLOC_CLASS {
  SEGLOC_CLASS_BEST,
  SEGLOC_CLASS_GOOD,
  SEGLOC_CLASS_BAD,
  SEGLOC_CLASS_UNKNOWN
} SEGLOC_CLASS;


#define SEGLOC_CLASS_NAME {\
  "Best",\
  "Good",\
  "Bad",\
  "Unknown"\
}

typedef struct SEGLOC_HYPS {
  Hyp *hyp;
  SEGLOC_CLASS class;
} SEGLOC_HYPS;

typedef struct SEGLOC_HYPS_STR {
  Hyp hyp;
  SEGLOC_CLASS class;
  int bestsegloc;
  double *robotAngle;
  int *numgp;
  Sgl *segmod;
  Sgl *segacq;
} SEGLOC_HYPS_STR;

int writeDataFile(FILE *file, SEGLOC_SEG_PARAMS *segParams,
		  SEGLOC_LOC_MODE locMode,
		  SEGLOC_LOC_PARAMS *locParams,
		  SEGLOC_POS_VAR *initPos,
		  SICK_MEASURES_HEADER_STR *header,
		  SEGLOC_HYPS hypTbl[],
		  int nbSol, int best,
		  int nbAcqSegs, double acqLength, double acqAngleView,
		  int nbAspectSegs, double aspectLength, double aspectAngleView);


int readDataFile(FILE *pfilein, SEGLOC_SEG_PARAMS *segParams,
		 SEGLOC_LOC_MODE *locMode,
		 SEGLOC_LOC_PARAMS *locParams,
		 SEGLOC_POS_VAR *initPos,
		 SICK_MEASURES_HEADER_STR *header,
		 SEGLOC_HYPS_STR *hypTbl[],
		 int *nbAcqSegs, double *acqLength, double *acqAngleView,
		 int *nbAspectSegs, double *aspectLength, double *aspectAngleView);

#endif /* SEGLOC_STATS_IO_H */
