#ifndef SEGLOC_UTILS_H
#define SEGLOC_UTILS_H

#include "seglocStruct.h"


/* valeur du test du Chi2 a 1 degres de liberte a 95% */
#define GAUSS_95 1.96
#define GAUSS_99 3.0 /* A peu prs ! */
/* valeur du test du Chi2 a 2 degres de liberte a 95% */
#define CHI2_95 2.447
/* valeur du test du Chi2 a 3 degres de liberte a 95% */

#define SEGLOC_VARIANCE(x) (SQR((x)/GAUSS_99))
#define SEGLOC_3SIGMA(x)   (GAUSS_99*sqrt(x))


void CalcAbsPos(SEGLOC_POS_VAR *odo, 
		SEGLOC_POS_VAR *transf,
		SEGLOC_POS_VAR *pos);

void calc_abs_pos(double xrob[3], double vrob[6],
		  double tr[3], double vtr[6],
		  double abs[3], double vabs[6]);

void seglocConvertVar2Matrix(double vX[6], SEGLOC_VARIANCES *var);
void seglocConvertMatrix2Var(SEGLOC_VARIANCES *var, double vX[6]);

#endif /* SEGLOC_UTILS_H */
