#ifndef DESSIN_SEG_H
#define DESSIN_SEG_H

typedef struct XAFF_POS {
  double x,y,theta;
} XAFF_POS;

extern double echelle;
extern int offset_x;
extern int offset_y;

extern int r_m_to_pixel ( double r );
extern int x_metre_to_pix ( double x );
extern double x_pix_to_metre ( short x );
extern int y_metre_to_pix ( double y );
extern double y_pix_to_metre ( short y );
extern void metrePix ( double x, double y, int *px, int *py );
extern void metrePixShort ( double x, double y, short *px, short *py );
extern void local_to_global ( XAFF_POS *pos, double xl, double yl, double *xg, double *yg );
extern void dessin_seg ( XAFF_POS *pos, double x0, double y0, double x1, double y1, GC gc );
extern void dessin_rects ( double *xtab, double *ytab, int nbRects, GC gc );
extern void dessin_rect_from_seg ( double x1, double y1, double x2, double y2, GC gc );
extern void dessin_seg_extremities ( XAFF_POS *pos, double x1in, double y1in, double x2in, double y2in, GC gc );
extern void dessin_my_robot ( XAFF_POS *pos, double capt, GC gc );
extern void dessin_robot_rond ( XAFF_POS *pos, double capt, GC gc );
extern void dessin_robot_h2 ( XAFF_POS *pos, double capt, GC gc );
extern void dessin_gros_point ( double xl, double yl, double size, GC gc );
extern void dessin_croix(double xl, double yl, double size, GC gc);

/*#include "dessin_seg_p.h"*/

#endif /* DESSIN_SEG_H */
