/*
 * Copyright (C) 1999 LAAS/CNRS 
 *
 * Matthieu Herrb - Wed Jun  9 1999
 *
 * $Source: /cvs/openrobots/modules/segloc/xaff/locoCompat.h,v $
 * $Revision: 1.1 $
 * $Date: 2005/09/07 10:17:58 $
 * 
 */
#ifndef _LOCOCOMPAT_H
#define _LOCOCOMPAT_H


/* XXXXX Compatibilite avec ancien loco */
#define REF_STR LOCO_REF_STR
#define ROBOT_ODO_STR LOCO_ROBOT_ODO_STR
#define ERROR_ODO_STR LOCO_ERROR_ODO_STR
#define DYNAMIC_SET_POS LOCO_DYNAMIC_SET_POS 

#define DIST_TO_CONTROLED_POINT LOCO_DIST_TO_CONTROLED_POINT
#define MOT_AXIS_WIDTH LOCO_MOT_AXIS_WIDTH

#define VMAX_ROBOT LOCO_VMAX_ROBOT 
#define WMAX_ROBOT LOCO_WMAX_ROBOT 
#define AMAX_LIN_ROBOT LOCO_AMAX_LIN_ROBOT 
#define AMAX_ANG_ROBOT LOCO_AMAX_ANG_ROBOT 
#define DIST_AXLE_TO_AXIS_STR LOCO_DIST_AXLE_TO_AXIS_STR


/* Compatibilite avec loco */
#define LOCO_DIST_TO_CONTROLED_POINT RFLEX_DIST_TO_CONTROLED_POINT
/* correction de RFLEX_MOT_AXIS_WIDTH en RFLEX_AXIS_WIDTH */
#define LOCO_MOT_AXIS_WIDTH RFLEX_AXIS_WIDTH

#define LOCO_VMAX_ROBOT RFLEX_VMAX_ROBOT
#define LOCO_WMAX_ROBOT RFLEX_WMAX_ROBOT
#define LOCO_AMAX_LIN_ROBOT RFLEX_AMAX_LIN_ROBOT
#define LOCO_AMAX_ANG_ROBOT RFLEX_AMAX_ANG_ROBOT

#define LOCO_MOTION_DIRECTION RFLEX_MOTION_DIRECTION
#define LOCO_BACKWARD_MOTION RFLEX_BACKWARD_MOTION
#define LOCO_FORWARD_MOTION RFLEX_FORWARD_MOTION

#define LOCO_REF_STR RFLEX_REF_STR
#define LOCO_ROBOT_ODO_STR RFLEX_ROBOT_ODO_STR
#define LOCO_ERROR_ODO_STR RFLEX_ERROR_ODO_STR

/* #define LOCO_DYNAMIC_SET_POS RFLEX_DYNAMIC_SET_POS */

#define locoPosterInit rflexPosterInit
#define locoRobotPositionPosterRead rflexRobotPositionPosterRead
#define locoRobotPosErrorPosterRead rflexRobotPosErrorPosterRead
#define locoDynamicSetPosRqstAndRcv rflexDynamicSetPosRqstAndRcv

/* Compatibilite avec pilo */
#define PILO_CMDTASK_LOCO_CLIENT_ID PILO_CMDTASK_RFLEX_CLIENT_ID
#define LOCO_TR_REF_STR             RFLEX_REF_STR
#define locoTrackEndRqstAndRcv      rflexTrackEndRqstAndRcv
#define locoTrackEndReplyRcv        rflexTrackEndReplyRcv
#define locoTrackStartReplyRcv      rflexTrackConfigStartReplyRcv
#define locoTrackStartRqstAndAck    rflexTrackConfigStartRqstAndAck
#define locoRobotPositionPosterRead rflexRobotPositionPosterRead
  
#define S_locoCntrlTask_ACTIVITY_INTERRUPTED S_rflexCntrlTask_ACTIVITY_INTERRUPTED


/* Compatibilite avec trPilo */
#define LOCO_DIST_AXLE_TO_AXIS_STR RFLEX_DIST_AXLE_TO_AXIS_STR
#define LOCO_POSTER_NAME           RFLEX_POSTER_NAME

/* Distance of the virtual wheel of dala to the robot center */
#define LOCO_DIST_CENTER_ROBOT_HITCH_POINT_OFF_AXLE   1.0
/* Set to zero to specify that there is no trailer */
#define LOCO_DIST_CENTER_TRAILER_HITCH_POINT_OFF_AXLE 0.0

/* LOCO_PHI_MAX, initally the max angle between hilare2 and its trailer, */
/* now used as the max steering angle of the cart-like robot wheel */
/* Value comes from Dala definition in Move3d with a max angle of 60 deg */
#define LOCO_PHI_MAX                  1.047

#define LOCO_SEC_PERIOD            RFLEX_SEC_PERIOD
#define LOCO_TICKS_PERIOD          RFLEX_TICKS_PERIOD

/* Compatibilite avec follow */
#define locoClientInit rflexClientInit
#define FOLLOW_CMDTASK_LOCO_CLIENT_ID  FOLLOW_CMDTASK_RFLEX_CLIENT_ID
#define locoTrackConfigStartRqstAndAck rflexTrackConfigStartRqstAndAck
#define locoTrackConfigStartReplyRcv   rflexTrackConfigStartReplyRcv
/* Celles ci ne sont jamais utilisees normalement */
#define locoTrackTrailerStartRqstAndAck rflexTrackConfigStartRqstAndAck
#define locoTrackTrailerStartReplyRcv rflexTrackConfigStartReplyRcv

#endif
